#include <iostream>
using namespace std;
#include "ezwin.h"
#include "rect.h"
#include <string>
#include <cassert>
#include <ctime>
#include "abhi.cpp" //sourefile

// prototypes of functions used in the program
void GamePlay();	// function that includes actual Gameplay
void CreateGUI();	// function creates GUI
void CreateMap();	// function creates the minefield in the grid
void display();		// function displays the minefield in the grid
void dispzero(int,int);	// function that opens the neighbouring boxes in case the value of the box is zero

//Declaring some varibles required in the code
int i,j;
int x,y;		// variables to give position of the Box in the Minesweeper Grid
float xcoord, ycoord;	// variables to give position (coordinates) of mouse click
string xc,yc;		// variables to give position of the Box in the Minesweeper Grid (in string format)
string strboard[10][10];	//array to give value of each box in the grid (in string format)
string flag[10][10];		//array to store status of box - whether it is flagged or not
string status[10][10];	// variables to give status of box - "False" = Deactive, "True" = Active
string Mode;		//Declaring GameMode as String - OpenBox or FlagBox
string ColorOpenBox, ColorFlagBox;	//Declaring Variables to check color of rectangles - Red or Green

//-----------------------------------------------------------------------------------------------------------------------------------
/*
	The following funtion "MouseClick" is invoked when the mouse is clicked in the MainWindow.
	It checks the coordinates of the Mouse Click, identifies the window & proceeds by calling the respective function
*/

int MouseClick(const Position &p)
{
	// extracting the x & y coordinates of the mouse click
	xcoord = p.GetXDistance();
	ycoord = p.GetYDistance();
	
	if (xcoord > 2 && xcoord < 6 && ycoord > 2 && ycoord < 6) 		//Checking whether mouse click is inside Restart Game Rectangle
	{
		CreateGUI();
		CreateMap();
	}
	else if (xcoord > 23 && xcoord < 27 && ycoord > 11 && ycoord < 15) 	//Checking whether mouse click is inside OpenBox Mode Rectangle
	{		
		if (ColorOpenBox == "Red" && Mode == "FlagBox") 
		{ 	
			ColorOpenBox = "Green"; 
			MainWindow.RenderRectangle(Position(23,11), Position(27,15),Green,true);
			MainWindow.RenderText(Position(23,11), Position(27,15), "OpenBox Mode", Black, Green);
			ColorFlagBox = "Red";
			MainWindow.RenderRectangle(Position(23,2), Position(27,6),Red,true);
			MainWindow.RenderText(Position(23,2), Position(27,6), "FlagBox Mode", Black, Red);
			
			Mode = "OpenBox";
			MainWindow.RenderText (Position(14.5,15), "OpenBox Mode is Active",Black,Green);
		}
	}

	else if (xcoord > 23 &&	xcoord<27 && ycoord > 2 && ycoord<6) 		//Checking whether mouse click is inside FlagBox Mode Rectangle
	{
		if (ColorFlagBox == "Red" && Mode == "OpenBox") 
		{ 	
			ColorFlagBox = "Green"; 
			MainWindow.RenderRectangle(Position(23,2), Position(27,6),Green,true);
			MainWindow.RenderText(Position(23,2), Position(27,6), "FlagBox Mode", Black, Green);
			ColorOpenBox = "Red";
			MainWindow.RenderRectangle(Position(23,11), Position(27,15),Red,true);
			MainWindow.RenderText(Position(23,11), Position(27,15), "OpenBox Mode", Black, Red);

			Mode = "FlagBox";
			MainWindow.RenderText (Position(14.5,15), "FlagBox Mode is Active",Black,Green);
		}
	}
	else if (xcoord > 10 && xcoord < 20 && ycoord > 4 && ycoord < 14)	// Checking whether the mouse click is inside the Game Grid
	{
		GamePlay();	
	}
	return 0;
}

//-----------------------------------------------------------------------------------------------------------------------------------
/*
	The following function "ApiMain" is the Main function which is executed first.
	It opens the MainWindow, then the 'loading' page & then creates the GUI & loads the minefield in the grid
	Also it call the function to be invoked when a mouse is clicked
*/

int ApiMain()
{
	MainWindow.Open();
	assert(MainWindow.GetStatus() == WindowOpen);
	displayloading();
	MainWindow.Close();
	MainWindow.Open();
	assert(MainWindow.GetStatus() == WindowOpen);
	CreateGUI();
	CreateMap();
	MainWindow.SetMouseClickCallback(MouseClick);
	return 0;
}	
//-----------------------------------------------------------------------------------------------------------------------------------
/*
	The Following function "GamePlay" is the backbone of the project
	It checks the box value.
	If the value is 
	9 --> Mine
	0 --> There is no mine in the surrounding 8 boxes
	1-8 --> The surrounding boxes contain 1-8 mines respectively
	In the OpenBox Mode the function opens that particular box
	In the FlagBox Mode the function display or removes a flag on the box
*/

void GamePlay()
{
	x=xcoord-10;
	y=ycoord-4;
	xc=x+48;
	yc=y+48;
	if (Mode == "OpenBox")
	{
		if (flag[x][y] == "False")
		{
			status[x][y] = "False";
			if (strboard[x][y] == "0")
			{	
			dispzero(x,y);
			}
			else if (strboard[x][y] != "9")
			{
				MainWindow.RenderText(Position(10.5+x,4.5+y),strboard[x][y],White,Black);
			}
			else if (strboard[x][y] == "9")
			{
				display();
				displayyoulose();
			}
		}
	}
	else if (Mode == "FlagBox")
	{
		if (flag[x][y] == "False" && status[x][y] == "True")
		{
			//MainWindow.RenderText(Position(10.5+x,4.5+y),"F",Green,Black);
			displayflag(10.1+x,4.1+y);
			flag[x][y] = "True";
		}
		else if (flag[x][y] == "True")
		{			
			MainWindow.RenderRectangle(Position(10.1+x , 4.1+y),Position(10.9+x,4.9+y),Black,false);
			flag[x][y] = "False";
		}
	}

}
//-----------------------------------------------------------------------------------------------------------------------------------
/*
	The following function "CreateGUI" creates the Graphic User Interface 
	for the project using lines & Rectangles
*/
void CreateGUI()
{
	//Black Rectangle, with border will act as background
	MainWindow.RenderRectangle(Position(0.0,0.0), Position(29.0,17.0), Black, true);

	//Black screen in middle act as work place
	MainWindow.RenderRectangle(Position(10.0,4.0), Position(20.0,14.0), Black, true);

	//side menu 1 - Click to Restart
	MainWindow.RenderRectangle(Position(2.0,2.0), Position(6.0,6.0), Red, true);

	//side menu 2 - Time
	MainWindow.RenderRectangle(Position(2.0,11.0), Position(6.0,15.0), Red, true);

	//side menu 3 - FlagBox Mode
	MainWindow.RenderRectangle(Position(23.0,2.0), Position(27.0,6.0), Red, true);

	//side menu 4 - OpenBox Mode
	MainWindow.RenderRectangle(Position(23.0,11.0), Position(27.0,15.0), Green, true);
	
	//Red Line;Thickness 0 will be used to make boxes
	for(i=4 ;i<=14;i++)
	{ 
		MainWindow.RenderLine(Position(10.0,i),Position(20.0,i), Red,0.0);
	}
	for(i=10 ;i<=20;i++)
	{
		MainWindow.RenderLine(Position(i,4.0),Position(i,14.0), Red,0.0);
	}

	//Displaying the text in the respective boxes as per their respective functions
	MainWindow.RenderText(Position(2.0,2.0), Position(6.0,6.0), "Click to Restart",Black,Red);		
	MainWindow.RenderText(Position(2.0,11.0), Position(6.0,15.0), "Time",Black,Red);
	MainWindow.RenderText(Position(23.0,2.0), Position(27.0,6.0), "FlagBox Mode",Black,Red);
	MainWindow.RenderText(Position(23.0,11.0), Position(27.0,15.0), "OpenBox Mode",Black,Green);
	MainWindow.RenderText (Position(14.5,15), "OpenBox Mode is Active",Black,Green);
	
	// Declaring Mode & Colour of OpenBox & FlagBox
	Mode = "OpenBox";
	ColorOpenBox = "Green";
	ColorFlagBox = "Red";
	
}



//-----------------------------------------------------------------------------------------------------------------------------------
/* 
	The following function "CreateMap" creates the minefield & loads it in the memory
	It uses the randomize funtion to find random numbers from 0 to 99,
	extracts the digits of the number generated as 	coordinates & places mines in these boxes (value of these boxes is 9)
	eg. say 65 is generated a mine will be placed at (6,5) in the grid
	
	It also increments the value of the surrounding boxes by 1 signifying that there is a mine in this box
	It stores the value of the boxes in int form in board[][] & in string form in strboard[][]
*/
void CreateMap()
{
	int sum = 0;
	int mines = 10, count = 0;
	int value[100];
	int board[10][10];
	int row, col;
	srand((unsigned)time(0));
	for (i=0;i<10;i++)
	{
		for (j=0;j<10;j++)
		{
			board[i][j] = 0;
			flag[i][j] = "False";
			status[i][j] = "True";
		}
	}
	
	for(i=0 ; i < mines+1 ; i++)
	{
		value[i]=0;		
		value[i]=rand()%100; // will generate a random value between 0 and 99
		for(j=0;j<i;j++)
		{
				// in case same value is repeated from rand function 
				if(value[i]==value[j])
				{
				        if(i!=j)
					{
						i--;
					}
				}
				else
				{
					// assigning mines to the blocks
					row = value[i-1]/10; 
					col = value[i-1]%10;		//b denotes the number of along a row or a column
					board[row][col]=9;  	// 9 denotes a mine in a particular block of the board*/
				}
					
		}		
	}
	
	for(i=0;i<10;i++)
	{
     		for(j=0;j<10;j++)
		{
	       		if(board[i][j]>=9)   // if there is a mine in the block
			{
				// increment the board value only if there is no mine	 
			
                                if(board[i-1][j-1] != 9)	board[i-1][j-1]++;
				if(board[i][j-1] != 9)		board[i][j-1]++;
                                if(board[i+1][j-1] != 9)	board[i+1][j-1]++;
                                if(board[i-1][j]!= 9)		board[i-1][j]++;
                                if(board[i+1][j] != 9)		board[i+1][j]++;
                                if(board[i-1][j+1] != 9)	board[i-1][j+1]++;
                                if(board[i][j+1] != 9)		board[i][j+1]++;
                                if(board[i+1][j+1] != 9)	board[i+1][j+1]++;
                         }
		}
	}
	for (i=0;i<10;i++)
	{
		for (j=0; j<10; j++)
		{	
			strboard[i][j] = board[i][j] + 48;

		}
	}
}

//-----------------------------------------------------------------------------------------------------------------------------------
/*
	The following function "display", displays the value of the boxes in the respective positions in the grid
	In case its a mine it displays the whole grid by calling the displaymine function
*/

void display()
{
	for (i=0;i<10;i++)
	{
		for (j=0; j<10; j++)
		{	
			if (flag[i][j] == "False")
			{
				status[i][j] = "False";
				if (strboard[i][j] == "9") 
				{
					//MainWindow.RenderText(Position(i+10.5,j+4.5),"*",White,Black);
					displaymine(i+10.2,j+4.3);			
				}
				else if (strboard[i][j] != "9") 
				{
					MainWindow.RenderText(Position(i+10.5,j+4.5),strboard[i][j],Blue,Black);			
				}
			}	
		}
	}
}

//-----------------------------------------------------------------------------------------------------------------------------------
/*
	The following function displays the board value of the 8 adjacent boxes in case a box with value 0 is clicked
*/

void dispzero(int p,int q)
{
	//if(temp[p][q] == "0")  // in case there are no adjacent mines to this box

	for(i=p-1 ; i<=p+1 ; i++)
	{
    		for(j=q-1 ; j<=q+1 ; j++)
    		{
			if (i>=0 && j>= 0 && i<10 && j<10 && flag[i][j] == "False") 
			{
				MainWindow.RenderText(Position(10.5+i,4.5+j),strboard[i][j],White,Black);
				status[i][j] = "False";
			}
		}
	}
}

//-----------------------------------------------------------------------------------------------------------------------------------


